/* run embedded module-function validations */

#include <stdio.h>
#include <string.h>
#include "pyembed.h"

struct {                  /* same as order1 */
    int product;   
    int quantity;
    char *buyer;  
} orders[] = {
    {111, 2, "ISpam"},  
    {222, 5, "ATest"}, 
    {141, 3, "USpam"},
    {222, 1, "4More"}, 
    {222, 0, "Stuff"},
    {131, 9, "NMore"} 
};
int numorders = 6;

run_user_validation()
{
    int i, status;                /* should check status everywhere */
    char *errors, *warnings;      /* no file/string or namespace here */
    PyObject *results;

    for (i=0; i < numorders; i++) {
        printf("\n%d (%d, %d, '%s')\n", 
            i, orders[i].product, orders[i].quantity, orders[i].buyer);

        status = Run_Function(
                         "order2", "validate",     /* order2.validate(p,q,b) */
                         "O",      &results,
                         "(iis)",   orders[i].product, 
                                    orders[i].quantity, orders[i].buyer);
        if (status == -1) {
            printf("Python error during validation.\n");
            PyErr_Print();  /* show traceback */
            continue;
        }
        PyArg_Parse(results, "(ss)", &warnings, &errors);
        Py_DECREF(results);
        printf("errors:   %s\n", strlen(errors)? errors : "none"); 
        printf("warnings: %s\n", strlen(warnings)? warnings : "none"); 
        Run_Function("inventory", "print_files", "", NULL, "()");    
    }
}

main(int argc, char **argv)
{
    run_user_validation();
}

char *getprogramname() { return "order2"; } 
