import sys, string                          # get built-in modules


class Input:                                # simulated input file
    def __init__(self, input=''):           # default argument	
        self.text = input                   # save string when created

    def read(self, *size):                  # optional argument
        if not size:                        # read N bytes, or all
            res, self.text = self.text, ''
        else:
            res, self.text = self.text[:size[0]], self.text[size[0]:]
        return res

    def readline(self):
        eoln = string.find(self.text, '\n')
        if eoln == -1: 
            res, self.text = self.text, ''
        else:
            res, self.text = self.text[:eoln+1], self.text[eoln+1:]
        return res


class Output:                               # simulated output file
    def __init__(self):			         
        self.text = ''                      # empty string when created

    def write(self, string):                # add a string of bytes
        self.text = self.text + string            

    def writelines(self, lines):
        for line in lines: self.write(line)


def redirect(input, function, args):        # redirect stdin/out
    std_streams = sys.stdin, sys.stdout     # run a function object 
    sys.stdin   = Input(input)              # return stdout text
    sys.stdout  = Output()
    try:
        apply(function, args)
    except:
        sys.stderr.write('error in function! ')
        sys.stderr.write(`sys.exc_type` + ',' + `sys.exc_value` + '\n')
    result = sys.stdout.text
    sys.stdin, sys.stdout = std_streams
    return result
