import os

def spawn(prog, args):
    pipe1 = os.pipe()                 # parent stdin, child stdout:  (in, out)
    pipe2 = os.pipe()                 # child stdin,  parent stdout: (in, out)
    pid = os.fork()                   # make a copy of this process
    if pid:
        os.close(pipe1[1])            # in parent process after fork
        os.close(pipe2[0])            # close child ends
        os.dup2(pipe1[0], 0)          # sys.stdin  = pipe1[0]
        os.dup2(pipe2[1], 1)          # sys.stdout = pipe2[1]
    else:
        os.close(pipe1[0])            # in child process after fork
        os.close(pipe2[1])            # close parent ends
        os.dup2(pipe2[0], 0)          # sys.stdin  = pipe2[0]
        os.dup2(pipe1[1], 1)          # sys.stdout = pipe1[1]
        args = (prog,) + args
        os.execv(prog, args)   # new program in this process: never returns here
